<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="运输方式" prop="transportType">
        <el-select v-model="queryParams.transportType" placeholder="请选择运输方式" clearable size="small">
          <el-option v-for="dict in transportTypes" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="始发地" prop="startWarehouseId">
        <el-select v-model="queryParams.startWarehouseId" placeholder="请选择始发地">
          <el-option v-for="item in exportWarehouseList" :label="item.titleZh" :value="item.id" :key="item.id"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item label="目的地" prop="destWarehouseId">
        <el-select v-model="queryParams.destWarehouseId" placeholder="请选择目的地">
          <el-option v-for="item in importWarehouseList" :label="item.titleZh" :value="item.id" :key="item.id"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:future-box:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['ecw:future-box:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="主键ID" align="center" prop="id" />
      <el-table-column label="始发地" align="center" prop="startWarehouse" />
      <el-table-column label="目的地" align="center" prop="destWarehouse" />
      <el-table-column label="运输方式" align="center" prop="transportType">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.ECW_TRANSPORT_TYPE" :value="scope.row.transportType" />
        </template>
      </el-table-column>
      <el-table-column label="出货渠道" align="center" prop="shippingChannelId" />
      <el-table-column label="待入仓方数" align="center" prop="readyWarehousingNumber" />
      <el-table-column label="已入仓方数" align="center" prop="warehousedNumber" />
      <el-table-column label="在仓方数" align="center" prop="warehousingNumber" />
      <el-table-column label="已装柜方数" align="center" prop="loadingNumber" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="未来天数" align="center" prop="futureNumber" />
      <el-table-column label="计划货柜" align="center" prop="gpNumber">
        <template slot-scope="{row}">
          {{row.gpNumber}}个40GP/{{row.hqNumber}}个40HQ
        </template>
      </el-table-column>
      <el-table-column label="未来计划方数" align="center" prop="futurePlanNumber" />
      <el-table-column label="未来实际方数" align="center" prop="actualNumber" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:future-box:update']">编辑</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['ecw:future-box:delete']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
         <el-form-item label="始发地" prop="startWarehouseId">
          <el-select v-model="form.startWarehouseId" placeholder="请选择始发地">
            <el-option v-for="item in exportWarehouseList" :label="item.titleZh" :value="item.id" :key="item.id"></el-option>
          </el-select>
        </el-form-item>

        <el-form-item label="目的地" prop="destWarehouseId">
          <el-select v-model="form.destWarehouseId" placeholder="请选择目的地">
            <el-option v-for="item in importWarehouseList" :label="item.titleZh" :value="item.id" :key="item.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="运输方式" prop="transportType">
          <el-radio-group v-model="form.transportType">
            <el-radio v-for="dict in transportTypes" :key="dict.value" :label="dict.value">{{dict.label}}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="出货渠道" prop="shippingChannelId">
          <el-select v-model="form.shippingChannelId" placeholder="请选择出货渠道">
            <el-option v-for="item in channelList" :label="item.nameZh" :value="item.channelId" :key="item.channelId"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="待入仓方数" prop="readyWarehousingNumber"/>
        <el-form-item label="已入仓方数" prop="warehousedNumber"/>
        <el-form-item label="在仓方数" prop="warehousingNumber"/>
        <el-form-item label="已装柜仓数" prop="loadingNumber"/>
        <el-form-item label="未来" />
        <el-form-item prop="futureNumber">
          <el-input v-model="form.futureNumber" placeholder="请输入未来货柜天数" />
        </el-form-item>
        <el-form-item label="天货柜数" />
        <el-form-item prop="gpNumber">
          <el-input v-model="form.gpNumber" placeholder="请输入GP" />
        </el-form-item>
        <el-form-item label="x40GP"/>
        <el-form-item prop="hqNumber">
          <el-input v-model="form.hqNumber" placeholder="请输入hq" />
        </el-form-item>
        <el-form-item label="x40HQ"/>
        <el-form-item label="未来计划方数" prop="futurePlanNumber">
          <el-input v-model="form.futurePlanNumber" placeholder="请输入未来计划方数" />
        </el-form-item>
        <el-form-item label="未来实际方数" prop="actualNumber">
          <el-input v-model="form.actualNumber" placeholder="请输入未来实际方数" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createFutureBox, updateFutureBox, deleteFutureBox, getFutureBox, getFutureBoxPage, exportFutureBoxExcel } from "@/api/ecw/futureBox";
import {getCabinetPage} from "@/api/ecw/cabinet";
import { getChannelList } from '@/api/ecw/channel';
import { getWarehouseList } from "@/api/ecw/warehouse"

export default {
  name: "indexFutureBox",
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 预定舱计划列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        startWarehouseId: null,
        destWarehouseId: null,
        transportType: null,
        readyWarehousingNumber: null,
        warehousedNumber: null,
        warehousingNumber: null,
        loadingNumber: null,
        futureNumber: null,
        gpNumber: null,
        hqNumber: null,
        futurePlanNumber: null,
        actualNumber: null,
        shippingChannelId: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      warehouseList: [],
      channelList: [],
    };
  },
  computed: {
    exportWarehouseList() {
      return this.warehouseList.filter(
        (item) => item.tradeType == "2" || item.type == "3"
      );
    },
    importWarehouseList() {
      return this.warehouseList.filter(
        (item) => item.tradeType == "1" || item.type == "3"
      );
    },
    getCabinetName() {
      return (cabinetId) => {
        for (let index in this.cabinetList) {
          let cabinetItem = this.cabinetList[index];
          if (cabinetItem.id == cabinetId) {
            return cabinetItem.name;
          }
        }
      };
    },
    getShipChannelName() {
        return shippingChannelId => {
          for (let index in this.channelList) {
            let channelItem = this.channelList[index];
            if (channelItem.channelId == shippingChannelId) {
              return channelItem.nameZh;
            }
          }
          return '/'
        }
    }
  },
  created() {
    // 查询渠道
    getChannelList().then((res) => (this.channelList = res.data));
    this.transportTypes = this.getDictDatas(
      this.DICT_TYPE.ECW_TRANSPORT_TYPE
    ).filter((item) => item.value == "1" || item.value == "2");
    getWarehouseList().then((res) => (this.warehouseList = res.data));
    getCabinetPage(null).then((response) => {
      this.cabinetList = response.data.list;
    });
    this.getList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getFutureBoxPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        startWarehouseId: undefined,
        destWarehouseId: undefined,
        transportType: undefined,
        readyWarehousingNumber: undefined,
        warehousedNumber: undefined,
        warehousingNumber: undefined,
        loadingNumber: undefined,
        futureNumber: undefined,
        gpNumber: undefined,
        hqNumber: undefined,
        futurePlanNumber: undefined,
        actualNumber: undefined,
        shippingChannelId: undefined,
        status: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加预定舱计划";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getFutureBox(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改预定舱计划";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateFutureBox(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createFutureBox(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除预定舱计划编号为"' + id + '"的数据项?').then(function() {
          return deleteFutureBox(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm('是否确认导出所有预定舱计划数据项?').then(() => {
          this.exportLoading = true;
          return exportFutureBoxExcel(params);
        }).then(response => {
          this.$download.excel(response, '${table.classComment}.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
